; The pingpong example

(require 'random)
(define (random-angle) (random 360))

(define (pingpong t)
   (if (look t 30 20 color-blue)
      (right! t (random-angle))
      (forward! t 10))
   (pingpong t))

(define (multi n t)
   (if (> n 0)
      (begin
         (new-thread 
            (sleep 0)
            (multi (- (eval@p n) 1) (clone-turtle (eval@p t))))
         (forward! t 30)
         (left! t 20)
         (sleep 0)
         (circle t 360)
         (kill-turtle! t))))

(define (circle t n)
   (sleep 0)
   (if (> n 0)
      (begin
         (forward! t 20)
         (right! t 10)
         (circle t (- n 10)))))


; (ant) is the control-loop of an single ant.
; Thread-local variables: *turtle*, *queue*

(define (little-ant)
;  (bind-to-console)
   (install-handler
      (lambda (msg)
         (cond 
            ((eq? msg 'monster)   (kill-turtle! t) (quit-thread))
          )))
   (define t (make-turtle *win* 'ant))
   (pen-up! t)
   (notify-when t 'monster 30 30 *monster*)
   (notify-on-click t 'monster)
   (set-heading! t (random-angle))
   (pingpong t))

(define (ants)
   (eval@ (base-environment)
;      (define *win* (new-window))
;      (set-background-color! *win* color-blue)
;      (load-bitmap *win* "antsdemo.bmp")
      (define *monster* (make-turtle *win* 'Monster)))
      (set-color! *monster* color-red)
      (new-thread (eval@p (pingpong *monster*)))
   (move-to! *monster* 140 70)
   (new-thread (little-ant))
   (new-thread (little-ant))
   (new-thread (little-ant))
   (new-thread (little-ant))
   (new-thread (little-ant))
)
